"use strict";

const name = process.argv[2];
const size = parseInt(process.argv[3], 10);
const reps = parseInt(process.argv[4], 10) + 2;

const test = require(`./${name}.js`);
const data = [];

for (let i = 0; i < size; i += 1) {
  data.push({ value: i + 1 });
}

const results = [[], []];

function process_results() {
  const [timings] = results;

  const iMin = timings.reduce(
    (idx1, val, idx2) => (timings[idx1] > timings[idx2] ? idx2 : idx1),
    0
  );
  timings.splice(iMin, 1);

  const iMax = timings.reduce(
    (idx1, val, idx2) => (timings[idx2] > timings[idx1] ? idx2 : idx1),
    0
  );
  timings.splice(iMax, 1);

  // console.log("Timings", JSON.stringify(timings));
  console.log(
    "Average",
    Math.round(timings.reduce((sum, val) => sum + val, 0) / timings.length)
  );
}

(function loop(i) {
  if (i === reps) {
    return process_results();
  }

  const t1 = Date.now();
  const r = test.run(data);
  const t2 = Date.now();

  results[0][i] = t2 - t1;
  results[1][i] = r;

  setImmediate(() => loop(i + 1));
})(0);
